package org.exoplatform.commons.utils;

import java.util.Properties;
import java.io.IOException;

public class MimeTypeResolver {

  private Properties mimeTypes = new Properties();

  private String defaultMimeType = "application/octet-stream";

  public MimeTypeResolver() {
    try {
      mimeTypes.load(getClass().getResourceAsStream("mimetypes.properties"));
    } catch (IOException e) {
      throw new InternalError("Unable to load mimetypes: " + e.toString());
    }
  }

  public String getDefaultMimeType() {
    return defaultMimeType;
  }

  public void setDefaultMimeType(String defaultMimeType) {
    this.defaultMimeType = defaultMimeType;
  }

  public String getMimeType(String filename) {
    String ext = filename.substring(filename.lastIndexOf(".") + 1);
    if (ext.equals("")) {
      ext = filename;
    }
    return mimeTypes.getProperty(ext.toLowerCase(), defaultMimeType);
  }

}
