/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.transaction;

import javax.transaction.RollbackException;
import javax.transaction.SystemException;
import javax.transaction.TransactionManager;
import javax.transaction.UserTransaction;
import javax.transaction.xa.XAResource;
import javax.transaction.xa.Xid;



/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: $
 */

public interface TransactionService {
  
  TransactionManager getTransactionManager();
  
  UserTransaction getUserTransaction();
  
  int getDefaultTimeout();
  
  void setTransactionTimeout(int seconds) throws SystemException;
  
  void enlistResource(XAResource xares) throws RollbackException, SystemException;
  
  void delistResource(XAResource xares) throws RollbackException, SystemException;
  
  Xid createXid();
  
}
