package org.exoplatform.services.organization;

import java.util.* ;
/**
 * Created by The eXo Platform SARL
 * Author : Mestrallet Benjamin
 *          benjmestrallet@users.sourceforge.net
 * Date: Aug 21, 2003
 * Time: 3:22:54 PM
 *
 * This is the interface for the membership type data model. Note that after each set method is called. 
 * The developer need to call @see MembershipTypeHandler.saveMembershipType(..) or 
 * @see MembershipTypeHandler.createMembershipType(..) to persist the change
 */
public interface  MembershipType  {
  /**
   * @return  the name name of the membership type. The name of  the membershipt type should be unique
   * in the membership type database.
   */
  public String   getName()  ;
  /**
   * @param s The name of the membership type
   * TODO This method  should not be available to the developer as it should call only once, When a 
   * new membership type record is created
   */
  public void     setName(String s)  ;
  /**
   * @return The description of  the membership  type
   */
  public String   getDescription()  ;
  /**
   * @param s  The new description of the membership type
   */
  public void     setDescription(String s) ;
  /**
   * @return The owner of the membership
   */
  public String   getOwner()  ;
  /**
   * @param s  The new owner of the membership
   */
  public void     setOwner(String s) ;
  /**
   * @return  The date that the membership type is saved to the database
   */
  public Date     getCreatedDate()  ;
  /**
   * @param d  the created date
   * TODO This method  should be managed by the organization service and the developer should not called 
   * this method.
   */
  public void     setCreatedDate(Date d)  ;
  /**
   * @return  The last time that an user modify  the data of the membership  type.
   */
  public Date     getModifiedDate()  ;
  /**
   * @param d  the modified date
   * TODO  this field  should be managed by the organization service and developer should not called 
   * this method.
   */
  public void     setModifiedDate(Date d) ;
}
