/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.ticket.impl;

import java.util.Date;
import org.exoplatform.services.ticket.Ticket;
import org.exoplatform.services.ticket.TicketCommand;


/**
 * Created by The eXo Platform SARL
 * Author : Chung Nguyen
 *          nguyenchung136@yahoo.com
 * Jan 5, 2006
 * @hibernate.class  table="EXO_TICKET"
 */
public class TicketImpl implements Ticket {
  private String id;
  private int   repeatCount ;
  private int   joinCount;
  private long liveTime;
  private int Status;
  
  private String[] users;
  private String owenCreator;
  private String ticketCommandClass ;
  private String properties ;
  private String[] requiredPermissions;
  private String description;
  private String lassAccessUser;
  private Date creationTime;
  private Date lastAccessTime;
  
  
  transient private TicketCommand ticketCommand ;
  
  
  /**
   * @hibernate.id  generator-class="assigned" unsaved-value="null"
   ***/
  public String getId() {  return id; }
  public void setId(String id) {   this.id = id; }

  /**
   * @hibernate.property
   **/
  public long getLiveTime() {  return liveTime; }
  public void setLiveTime(long liveTime) {   this.liveTime = liveTime; }
  
  /**
   * @hibernate.property
   **/
  public int  getLimitAccess() {  return repeatCount ; }
  public void setLimitAccess(int c) { repeatCount = c ; }
  
  /**
   * @hibernate.property
   **/
  public String getStatTime(){
    if(creationTime==null) return null;
    return Long.toString(creationTime.getTime()); 
  }
  public void setStatTime(String time){ 
      Date dateFomat=new Date(Long.parseLong(time));
      creationTime=dateFomat;
  }
  
  public void setCreationTime(Date date) { creationTime = date;  }
  public Date getCreationTime() { return creationTime;  }
  
  /**
   * @hibernate.property
   **/
  public String getUsers() {
    if(users == null)  return null ;
    StringBuilder b = new StringBuilder() ;
    for(int i = 0; i < users.length; i++) {
      b.append(users[i]) ;
      if(i != users.length - 1) b.append('|') ;
    }
    return b.toString() ; 
  }  
  public void setUsers(String userList) {
    if(userList!=null){
      users = userList.split("\\|");    
      for(int i = 0 ; i < users.length; i++){
        users[i] = users[i].trim()  ;
      }
    }else users=null;
    
  }
  public String[] getAlowUsers() {  return users; }
  public void setAllowedUsers(String[] allusers) { users = allusers ; }
  
  /**
   * @hibernate.property
   **/
  public String getPermissions(){
    if(requiredPermissions==null) return null;
    StringBuilder b=new StringBuilder();
    for(int i=0;i<requiredPermissions.length;i++){
      b.append(requiredPermissions[i]);
      if(i!=requiredPermissions.length-1) b.append("|");
    }
    return b.toString();
  }
  public void setPermissions(String Permissions ){
    if(Permissions!=null){
      requiredPermissions=Permissions.split("\\|");
      for(int i = 0 ; i < requiredPermissions.length; i++){
        requiredPermissions[i] = requiredPermissions[i].trim()  ;
      }
    }else requiredPermissions=null;
      
  }
  public String[] getRequiredPermissions() { return this.requiredPermissions;  }
  public void setRequiredPermissions(String[] requiredPermissions) {
    this.requiredPermissions=requiredPermissions;
  }
  /**
   * @hibernate.property
   **/
  public int getAccessCounter() { return joinCount; }
  public void setAccessCounter(int count){ joinCount=count; }
  
  /**
   * @hibernate.property
   **/
  public int getStatus() { return Status; }
  public void setStatus(int status){ Status=status;}
  
  /**
   * @hibernate.property
   **/
  public String getCreator() { return owenCreator; }
  public void setCreator(String name){ owenCreator=name;  }
  
  /**
   * @hibernate.property
   **/
  public String getTicketCommandClass(){ return ticketCommandClass ; }  
  public void setTicketCommandClass(String commandClass){ticketCommandClass = commandClass; }
  
  /**
   * @hibernate.property
   **/
  public String getProperties() { return properties;  }
  public void setProperties(String prop){ properties=prop;}
  
  /**
   * @hibernate.property
   **/
  public String getLastAccessUser() {  return lassAccessUser;  }
  public void setLastAccessUser(String userAccess){ lassAccessUser=userAccess;  }
  
  /**
   * @hibernate.property
   **/
  public String getDescription() { return description;  }
  public void setDescription(String desc) { this.description = desc; }
  
  public TicketCommand getTicketCommand() { return ticketCommand ; }
  public void setTicketCommand(TicketCommand command) { ticketCommand = command ; }
  
  public Date getLastAccessTime() {   
    Long statTime=getCreationTime().getTime();
    lastAccessTime=new Date(statTime+getLiveTime());
    return lastAccessTime; 
  }
  
  public String getStatusLock(){
    String statusLock = "";
    int statusNum=getStatus();
    if(statusNum == -1)statusLock = "UNLIMITED_ACCESS";
    if(statusNum == 0) statusLock = "VALID_STATUS";
    if(statusNum == 1) statusLock = "EXPIRED_STATUS";
    if(statusNum == 2) statusLock = "LOCKED_STATUS";
    return statusLock ;
  }
}