/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.config.model;

/**
 * May 13, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: Portlet.java,v 1.7 2004/09/30 01:00:05 tuan08 Exp $
 **/
public class Portlet extends Component {
  private String title;
  private String windowId ;
  private String portletStyle ;
  private Permission editPreferencesPermission ;
  private boolean  showInfoBar = true ;
  private boolean  showWindowState = true ;
  private boolean  showPortletMode = true ;
  private PortletPreferences portletPreferences ;
  
  public String getTitle() { return title ; }
  public void   setTitle(String s) { title = s ;}
  
  public String getWindowId() { return windowId ; }
  public void   setWindowId(String s) { windowId = s ;}
  
  public String getPortletStyle() {
    if(portletStyle == null) return "default" ;
    return  portletStyle ; 
  }
  public void   setPortletStyle(String s) { portletStyle = s ;}
  
  public Permission getEditPreferencesPermission() { return editPreferencesPermission ;}
  public void setEditPreferencesPermission(Permission p) { editPreferencesPermission = p;}
  
  public boolean getShowInfoBar() { return showInfoBar ; }
  public void    setShowInfoBar(boolean b) { showInfoBar = b ; }
  
  public boolean getShowWindowState() { return showWindowState ; }
  public void    setShowWindowState(boolean b) { showWindowState = b ; }
  
  public boolean getShowPortletMode() { return showPortletMode ; }
  public void    setShowPortletMode(boolean b) { showPortletMode = b ; }
  
  public PortletPreferences getPortletPreferences() { return portletPreferences ; }
  public void setPortletPreferences(PortletPreferences prefs) { portletPreferences = prefs ; }
  
  public Component softCloneObject() {
  	Portlet portlet = new Portlet() ;
  	portlet.copyBasicProperties(this) ;
  	portlet.setTitle(title) ;
  	portlet.setWindowId(windowId) ;
  	portlet.setPortletStyle(portletStyle) ;
  	portlet.setShowInfoBar(showInfoBar) ;
  	portlet.setShowWindowState(showWindowState) ;
    portlet.setShowPortletMode(showPortletMode) ;
  	portlet.setPortletPreferences(portletPreferences);
    if(editPreferencesPermission != null) {
      portlet.setEditPreferencesPermission(new Permission(editPreferencesPermission)) ;
    }
  	return portlet ;
  }
}