/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.renderer.html.page;

import java.io.IOException;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.exoplatform.Constants;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.portal.PortalConstants;
import org.exoplatform.portal.faces.component.UIPage;
import org.exoplatform.portal.faces.component.UIPortalComponent;
import org.exoplatform.portal.faces.renderer.BaseRenderer;
import org.exoplatform.portal.session.RequestInfo;
import org.exoplatform.services.log.LogUtil;
/**
 * Date: Aug 11, 2003
 * @author : Mestrallet Benjamin
 * @email:   benjmestrallet@users.sourceforge.net
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: PageRenderer.java,v 1.6 2004/08/28 18:59:18 tuan08 Exp $
 */
public class PageRenderer extends BaseRenderer {
  
  public void encodeChildren( FacesContext context, UIComponent component ) throws IOException {
    ResponseWriter w = context.getResponseWriter() ;
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext());
    UIPage uiPage = (UIPage) component ;
    try {
      VelocityContext vcontext = new VelocityContext() ;
      vcontext.put(UIExoComponent.UICOMPONENT, uiPage) ;
      vcontext.put("context", context) ;
      vcontext.put("res", res) ;
      vcontext.put("renderer", this) ;
      vcontext.put("componentId", uiPage.getId()) ;
      vcontext.put("model", uiPage.getComponentModel()) ;    
      if(uiPage.getMode() == UIPortalComponent.COMPONENT_EDIT_MODE) {
        vcontext.put("mode", "edit") ;
        vcontext.put("addPortletParams", PortalConstants.addPortletParams);
        vcontext.put("addContainerParams", PortalConstants.addContainerParams);
        vcontext.put("editParams", PortalConstants.editParams);
        RequestInfo rinfo = (RequestInfo) SessionContainer.getComponent(RequestInfo.class);
        String dragDropActionURL = rinfo.getOwnerURI() + "?" +  Constants.COMPONENT_PARAMETER + "=" + uiPage.getId() +
                                   "&" + PortalConstants.PORTAL_ACTION + "=" + 
                                   PortalConstants.DRAG_DROP_ACTION ;        
        
        vcontext.put("dragDropActionURL", dragDropActionURL) ;
      } else {
        vcontext.put("mode", "view") ;
      }
      Template template = getTemplate(component, context) ;
      template.merge(vcontext, w) ;
    } catch (Exception ex) {
      LogUtil.getLog(getClass()).error("Render  Error: ", ex) ;
    }
  }
  
  public  boolean hasMaximizedPortlet(UIPage uiPage) {
    return uiPage.getMaximizedPortlet()  != null ;
  }
}