/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.test;

import java.util.Locale;

import javax.servlet.http.HttpServletResponse;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.portal.filter.RequestFact;
import org.exoplatform.portal.filter.RequestFilterRule;
import org.exoplatform.test.BasicTestCase;
import org.exoplatform.test.mocks.servlet.EmptyResponse;
import org.exoplatform.test.mocks.servlet.MockHttpSession;
import org.exoplatform.test.mocks.servlet.MockServletRequest;
import org.exoplatform.test.mocks.servlet.MockServletResponse;
/**
 * Thu, May 15, 2004 @   
 * @author: Tuan Nguyen
 * @version: $Id: TestUIComponentFactory.java,v 1.4 2004/08/05 14:58:42 tuan08 Exp $
 * @email: tuan08@yahoo.com
 */
public class TestRequestFilter extends BasicTestCase {
  static private RequestFilterRule rule_ ;
  static private PortalContainer pcontainer_ ;
  
  public TestRequestFilter(String name) {
    super(name);
  }

  public void setUp() throws Exception {
    if(pcontainer_ == null) {
      pcontainer_ = PortalContainer.getInstance() ;
      rule_ = 
        (RequestFilterRule)  pcontainer_.getComponentInstanceOfType(RequestFilterRule.class) ;
    }
  }
  

  public void testPublicRequestFilter() throws Exception {
    assertTrue(rule_ != null) ;
    RequestFact fact = getFact("/portal/faces/public/exo") ;
    rule_.verify(fact) ;
  }
  
  private RequestFact getFact(String path) throws Exception {
    MockServletRequest request = 
      new MockServletRequest(new MockHttpSession(), Locale.US, true);
    request.setRequestURI(path) ;
    request.setPathInfo("/exo") ;
    HttpServletResponse response = new MockServletResponse(new EmptyResponse());
    RequestFact fact = new RequestFact(pcontainer_, request, response) ;
    return fact ;
  }
}