package org.exoplatform.portlet.faces.lifecycle;

import java.util.HashMap;
import java.util.Iterator;

import javax.faces.FacesException;
import javax.faces.event.PhaseId;
import javax.faces.lifecycle.Lifecycle;
import javax.faces.lifecycle.LifecycleFactory;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.LogUtil;

public class ExoLifecycleFactory extends LifecycleFactory {
	protected static Log log_ = LogUtil.getLog("org.exoplatform.portal.faces") ;
  static final int FIRST_PHASE;
  static final int LAST_PHASE;
  protected HashMap lifecycleMap;

  static 
  {
    FIRST_PHASE = PhaseId.RESTORE_VIEW.getOrdinal();
    LAST_PHASE = PhaseId.RENDER_RESPONSE.getOrdinal();
  }

  static class LifecycleWrapper {
    Lifecycle instance;
    boolean created;

    LifecycleWrapper(Lifecycle newInstance, boolean newCreated) {
      instance = null;
      created = false;
      instance = newInstance;
      created = newCreated;
    }
  }


  public ExoLifecycleFactory() {
    lifecycleMap = null;
    lifecycleMap = new HashMap();
    lifecycleMap.put("DEFAULT", new LifecycleWrapper(new ExoLifecycle(), false));
  }

  public void addLifecycle(String lifecycleId, Lifecycle lifecycle) {
    if(lifecycleId == null || lifecycle == null)
      throw new NullPointerException("NULL PARAMETERS ERROR");
    if(null != lifecycleMap.get(lifecycleId)) {
      Object params[] = { lifecycleId };
      String message = "LIFECYCLE ID ALREADY ADDED" ;
      throw new IllegalArgumentException(message);
    }
    lifecycleMap.put(lifecycleId, new LifecycleWrapper(lifecycle, false));
  }

  public Lifecycle getLifecycle(String lifecycleId) throws FacesException {
    Lifecycle result = null;
    LifecycleWrapper wrapper = null;
    if(null == lifecycleId)
      throw new NullPointerException("com.sun.faces.NULL_PARAMETERS_ERROR") ;
    try {
      wrapper = (LifecycleWrapper)lifecycleMap.get(lifecycleId);
      result = wrapper.instance;
      wrapper.created = true;
    } catch(Throwable e) {
      Object params[] = { lifecycleId };
      String message = "CANT CREATE LIFECYCLE ERROR" ;
      throw new FacesException(message);
    }
    return result;
  }

  public Iterator getLifecycleIds() {
    return lifecycleMap.keySet().iterator();
  }
}
