/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.display.component;

import java.util.ResourceBundle;

import org.exoplatform.container.SessionContainer;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UITextArea;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.validator.EmptyFieldValidator;
import org.exoplatform.portal.Information;
import org.exoplatform.portal.config.content.DocumentContent;


/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIContentConfigForm.java,v 1.4 2004/08/17 13:07:02 tuan08 Exp $
 */
public class UIContentConfigForm extends UISimpleForm {
  
  private UITextArea textArea_ ;
  private DocumentContent documentContent_ = null;
  
  public UIContentConfigForm() {
    super("configForm", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer") ;    
    
    textArea_ = new UITextArea("content","") ;
    textArea_.setClazz("large") ;
    textArea_.addValidator(EmptyFieldValidator.class) ;
    add(textArea_) ;
    
    addActionListener(SaveActionListener.class, SAVE_ACTION) ;  
  }
  
  public void setContentConfig(DocumentContent documentContent) {
    documentContent_ = documentContent ;
    if (documentContent_ == null) {
      textArea_.setText("") ; 
    } else {            
      textArea_.setText(documentContent.getContent()) ;
    }
    textArea_.setEditable(true) ;
  }
    
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      ResourceBundle res = getApplicationResourceBundle() ;
      UIContentConfigForm uiForm = (UIContentConfigForm)event.getSource() ;
      UIContentConfig uiConfig = (UIContentConfig)uiForm.getParent() ;
      Information iprovider = findInformationProvider(uiForm) ;
      String content = uiForm.textArea_.getValue() ;      
      String owner = SessionContainer.getInstance().getOwner() ;      
      if(uiConfig.dContent_ == null) {
        DocumentContent documentContent = uiConfig.contentService_.createDocumentContentInstance() ;
        String id = uiConfig.generatorService_.generateStringID(documentContent) ;
        documentContent.setId(id) ;
        documentContent.setContent(content) ;
        documentContent.setOwner(owner) ;
        uiConfig.saveContentConfig(documentContent) ;
        uiForm.setContentConfig(documentContent) ;
        iprovider.addMessage(
            new ExoFacesMessage(res.getString("UIContentConfigForm.msg.save-sucessful"))) ;        
      }                  
      else {
        if(!owner.equals(uiForm.documentContent_.getOwner())) {
          iprovider.addMessage(
              new ExoFacesMessage(res.getString("UIContentConfigForm.msg.unable-modify"))) ;
          return ;
        }
        uiForm.documentContent_.setContent(content) ;
        uiConfig.contentService_.update(uiForm.documentContent_) ;
        iprovider.addMessage(
            new ExoFacesMessage(res.getString("UIContentConfigForm.msg.modify-sucessful"))) ;
      }
    }
  }  
}