/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.portletcontainer.test.filters;

import java.io.IOException;
import java.util.*;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.portlet.PortletMode;
import javax.portlet.WindowState;
import org.apache.commons.lang.StringUtils;
import org.exoplatform.Constants;
//import org.exoplatform.container.PortalContainer;
//import org.exoplatform.container.RootContainer;
import org.exoplatform.container.StandaloneContainer;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.services.portletcontainer.PortletContainerService;
import org.exoplatform.services.portletcontainer.pci.ActionInput;
import org.exoplatform.services.portletcontainer.pci.ActionOutput;
import org.exoplatform.services.portletcontainer.pci.Output;
import org.exoplatform.services.portletcontainer.pci.PortletData;
import org.exoplatform.services.portletcontainer.pci.RenderInput;
import org.exoplatform.services.portletcontainer.pci.RenderOutput;

/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:lautarul@gmail.com">Roman Pedchenko</a>
 * @version $Id: PortletFilter.java 6167 2006-06-13 11:05:38Z sunman $
 */

public class PortletFilter implements Filter {

  HashMap wins = null;
  
  protected void createWins(Map allPortletMetaData) {
    wins = new HashMap();
    Set keys = allPortletMetaData.keySet();
    Iterator i = keys.iterator();
    while(i.hasNext()) {
      String key = (String) i.next();
      PortletData portlet = (PortletData) allPortletMetaData.get(key);
      String portletApp = key.replace('.' , '/');
      String[] ss = StringUtils.split(portletApp, "/");

      WindowID2 windowID = new WindowID2();
      windowID.setOwner(Constants.ANON_USER);
      windowID.setPortletApplicationName(ss[0]);
      windowID.setPortletName(ss[1]);
      windowID.setUniqueID(portletApp);
      windowID.setPersistenceId("persistenceID");
      windowID.setPortletMode(PortletMode.VIEW);
      windowID.setWindowState(WindowState.NORMAL);
      wins.put(portletApp, windowID);
System.out.println("creating: " + portletApp + ": windowID: " + windowID);
    }
  }

  public HttpServletResponse createDummyResponse(HttpServletResponse original) {
System.out.println("name: " + original.getClass().getName());
    if (original.getClass().getName().equals("weblogic.servlet.internal.ServletResponseImpl") || original.getClass().getName().equals("com.ibm.ws.webcontainer.srt.SRTServletResponse")) {
System.out.println("  yes!!!!!!!!!!!!!!!!!!!!!");
//      Class responseClass = original.class.
      return new DummyResponse();
    } else
      return original;
  }
  
  public void init(FilterConfig filterConfig) {
  }

  public void doFilter(ServletRequest servletRequest,
      ServletResponse servletResponse, FilterChain filterChain)
      throws IOException, ServletException {

    HttpServletRequest httpRequest = (HttpServletRequest) servletRequest;
    HttpServletResponse httpResponse = (HttpServletResponse) servletResponse;
    ServletContext ctx = httpRequest.getSession().getServletContext();

    httpRequest.getSession().removeAttribute("titles");
    httpRequest.getSession().removeAttribute("fqTitles");
    httpRequest.getSession().removeAttribute("outs");

    try {
/*
      PortalContainer portalContainer = PortalContainer.getInstance();
      if (portalContainer == null) {
        RootContainer rootContainer = RootContainer.getInstance();
        portalContainer = 
          rootContainer.getPortalContainer(ctx.getServletContextName());
        PortalContainer.setInstance(portalContainer);
      }
*/
      StandaloneContainer portalContainer = StandaloneContainer.getInstance();
      PortletContainerService service = 
        (PortletContainerService) portalContainer.getComponentInstanceOfType(PortletContainerService.class);
      SessionContainer sessionContainer = 
        (SessionContainer) portalContainer.getComponentInstanceOfType(SessionContainer.class);
      if (sessionContainer == null) // creating session container if there isn't any
        sessionContainer = portalContainer.createSessionContainer("sessioncontainer", "user");

      // -----------------------------------------------------------------------------------------------------

      HttpServletResponse dummyHttpResponse = createDummyResponse(httpResponse);
      
      // -----------------------------------------------------------------------------------------------------

      Map allPortletMetaData = service.getAllPortletMetaData();

System.out.println("portlet metadata count: " + allPortletMetaData.size());
      if (wins == null)
        createWins(allPortletMetaData);

      HashMap portalParams = new HashMap();
      HashMap portletParams = new HashMap();

      Helper.parseParams(httpRequest, portalParams, portletParams);
      String component = (String) portalParams.get(Constants.COMPONENT_PARAMETER);
      boolean isAction = Helper.getActionType((String) portalParams.get(Constants.TYPE_PARAMETER));
      PortletMode portletMode = Helper.getPortletMode((String) portalParams.get(Constants.PORTLET_MODE_PARAMETER));
      WindowState windowState = Helper.getWindowState((String) portalParams.get(Constants.WINDOW_STATE_PARAMETER));
      
      ArrayList outs = new ArrayList();
      ArrayList titles = new ArrayList();
      ArrayList fqTitles = new ArrayList();
      
      Set keys = allPortletMetaData.keySet();
      Iterator i = keys.iterator();
      while(i.hasNext()) {
        String key = (String) i.next();
        PortletData portlet = (PortletData) allPortletMetaData.get(key);
        String portletApp = key.replace('.' , '/');
        String[] ss = StringUtils.split(portletApp, "/");

        WindowID2 win = (WindowID2) wins.get(portletApp);
        RenderInput renderInput = new RenderInput();
        renderInput.setWindowID(win);
        renderInput.setBaseURL("/" + ctx.getServletContextName() + "?" + Constants.COMPONENT_PARAMETER +
          "=" + win.getUniqueID());
        renderInput.setUserAttributes(new HashMap());
        renderInput.setMarkup("text/html");
        if (component != null && component.equals(portletApp))
          renderInput.setRenderParameters(portletParams);
        else
          renderInput.setRenderParameters(new HashMap());

        if (isAction && component != null && component.equals(portletApp)) {
System.out.println("processing action: " + portletApp + ": windowID: " + renderInput.getWindowID());
          ActionInput actionInput = new ActionInput();
          actionInput.setWindowID(win);
          actionInput.setBaseURL(renderInput.getBaseURL());
          actionInput.setUserAttributes(new HashMap());
          actionInput.setPortletMode(portletMode);
          actionInput.setWindowState(windowState);
          actionInput.setMarkup("text/html");
          try {
            ActionOutput o1 = service.processAction(httpRequest, dummyHttpResponse, actionInput);
            renderInput.getRenderParameters().putAll(o1.getRenderParameters());
            win.setPortletMode(portletMode);
            win.setWindowState(windowState);
/*
            if (o1.getNextMode() != null)
              win.setPortletMode(o1.getNextMode());
            if (o1.getNextState() != null)
              win.setWindowState(o1.getNextState());
*/
          } catch (Exception e2) {
            System.out.println(" !!!!!!!!!!!! error processing action of portlet " + portletApp + ": " + e2);
            e2.printStackTrace();
            System.out.println(" !!!!!!!!!!!! trying to continue...");
          }
        }

        renderInput.setPortletMode(win.getPortletMode());
        renderInput.setWindowState(win.getWindowState());
System.out.println("rendering: " + portletApp + ": windowID: " + renderInput.getWindowID());
System.out.println("  -- state: " + renderInput.getWindowState().toString() + "; mode: " + renderInput.getPortletMode().toString());
        try {
          RenderOutput o = service.render(httpRequest, dummyHttpResponse, renderInput);
          titles.add(o.getTitle() + " {mode: " + renderInput.getPortletMode().toString() + "; state: " +
            renderInput.getWindowState().toString() + "}");
          fqTitles.add(portletApp);
          outs.add(new String(o.getContent()));
        } catch (Exception e1) {
          System.out.println(" !!!!!!!!!!!! error rendering portlet " + portletApp + ": " + e1);
          e1.printStackTrace();
          System.out.println(" !!!!!!!!!!!! trying to continue...");
        }
      }
      
      httpRequest.getSession().setAttribute("titles", titles);
      httpRequest.getSession().setAttribute("fqTitles", fqTitles);
      httpRequest.getSession().setAttribute("outs", outs);
    } catch (Exception e) {
      e.printStackTrace();
      httpRequest.getSession().setAttribute("titles", null);
      httpRequest.getSession().setAttribute("fqTitles", null);
      httpRequest.getSession().setAttribute("outs", null);
      return;
    }

    filterChain.doFilter(servletRequest, servletResponse);
  }

  public void destroy() {
  }

}
