/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.web.report;

import java.util.List;

import org.exoplatform.test.web.TestSuites;
import org.exoplatform.test.web.WebUnitMonitor;
import org.exoplatform.test.web.WebUnitSuite;
import org.exoplatform.test.web.unit.WebUnit;


/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Feb 20, 2006
 */
abstract public class Report {
  protected TestSuites tsuites_ ;

  
  public Report(TestSuites tsuites) {
    tsuites_ =  tsuites ;
    
  }
  
  abstract public void report() throws Exception ;
  
  protected int countUnit(List<WebUnitSuite> suites) {
    int count = 0 ;
    for(WebUnitSuite suite: suites) {
      count += suite.getWebUnits().size()  ;
    }
    return count ;
  }
  
  protected int countStatus(List<WebUnitSuite> suites, int status) {
    int count = 0 ;
    for(WebUnitSuite suite: suites) {
      count += countStatus(suite, status) ;
    }
    return count ;
  }
  
  protected int countStatus(WebUnitSuite suite, int status) {
    int count = 0 ;
    for(WebUnit unit: suite.getWebUnits()) {
      if(unit.getStatus() == status) count++ ;
    }
    return count ;
  }
  
  protected int countUnitRun(WebUnitSuite suite) {
    int count = 0 ;
    for(WebUnit unit: suite.getWebUnits()) {
      WebUnitMonitor monitor =  unit.getMonitor() ;
      count += monitor.getCounter() ;
    }
    return count ;
  }
  
  protected int countAvgExecutionTime(WebUnitSuite suite) {
    int count = 0 ;
    for(WebUnit unit: suite.getWebUnits()) {
      WebUnitMonitor monitor =  unit.getMonitor() ;
      count += monitor.getAvgExecutionTime() ;
    }
    return count ;
  }
}
