/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.account ;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.unit.NewSessionUnit;
import org.exoplatform.test.web.validator.*;
/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: NewAccountSuite.java,v 1.1 2004/10/11 23:27:29 tuan08 Exp $
 **/
public class CheckNewAccountSuite extends WebUnitSuite {
  static String DESC="Check create a new user account";
  static String NAME="CheckNewAccountSuite";
    
  public CheckNewAccountSuite() {
    super(NAME, DESC);    
    addWebUnit(
      new NewSessionUnit("NewSession", "Create new session and go to the home page for the first time")
    );    
    addWebUnit(
      new ClickLinkWithText("GoToMyPortalPage", "Tell the web client click on the My Portal page").      
      setTextLink("My Portal").
      addValidator(new ExpectTextValidator("New Account"))
    ) ;    
    addWebUnit(
      new SubmitFormUnit("BlankAccount", "All fields are blank").
      setFormId("accountForm").
      setField("username", "").
      setField("password1x", "").
      setField("password2x", "").
      setField("firstname", "").
      setField("lastname", "").
      setField("email", "").
      setField("op", "save").     
      addValidator(new ExpectTextValidator("The field \"username\" cannot be empty")).      
      addValidator(new ExpectTextValidator("You forgot to enter the field \"password1x")).
      addValidator(new ExpectTextValidator("You forgot to enter the field \"password2x")).      
      addValidator(new ExpectTextValidator("You forgot to enter the field \"firstname")).      
      addValidator(new ExpectTextValidator("You forgot to enter the field \"lastname")).
      addValidator(new ExpectTextValidator("You have entered \"\" in field email, it is an invalid email address"))
    ) ;        
    addWebUnit(
      new SubmitFormUnit("NotSamePasswordAccount", "Two password are not same").
      setFormId("accountForm").
      setField("username", "#{client.name}").
      setField("password1x", "client.password1").
      setField("password2x", "client.password2").
      setField("firstname", "#{client.name}").
      setField("lastname", "#{client.name}").
      setField("email", "user@localhost.net").
      setField("op", "save").     
      addValidator(new ExpectTextValidator("password fields cannot be empty and must be the same value"))
    ) ;        
    addWebUnit(
      new SubmitFormUnit("InvalidEmailAccount", "email is invalid").
      setFormId("accountForm").
      setField("username", "#{client.name}").
      setField("password1x", "#{client.name}").
      setField("password2x", "#{client.name}").
      setField("firstname", "#{client.name}").
      setField("lastname", "#{client.name}").      
      setField("email", "client.email").
      setField("op", "save").     
      addValidator(new ExpectTextValidator("You have entered \"client.email\" in field email, it is an invalid email address"))
    ) ;        
    addWebUnit(
      new SubmitFormUnit("CreateNewAccount", "Create exoplatform account").
      setFormId("accountForm").
      setField("username", "#{client.name}").
      setField("password1x", "#{client.name}").
      setField("password2x", "#{client.name}").
      setField("firstname", "#{client.name}").
      setField("lastname", "#{client.name}").
      setField("email", "user@localhost.net").
      setField("op","save").
      addValidator(new ExpectTextValidator("New user has been created")) 
    ) ;    
  }
}