/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * This suite does :
 *    1) Go to home page and click on Edit Page Mode
 *    2) Add portlet content browse
 *    3) Login with account demo and go to home/users/demo to add a new folder
 *    4) Add a new document with type is nt:file and a new document with type is exo:article
 *    5) Go back to current user and check some basic actions of path config,query config,script config,document config
 *    6) Login with account demo and delete 2 file test-doc 
 *  
 * Created by The eXo Platform SARL
 * Author : Hoa Nguyen Thi
 *          hoa.nguyen@exoplatform.com, hoa2501@yahoo.com
 * Apr 25, 2006
 */
public class UserContentBrowseSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, click on Info tab, click on Manage Categories button and to do somethings" ;
  static String NAME = "UserContentBrowseSuite" ;
  String COMMENT  = "You must run AdminManageTaxonomySuite and AdminViewSuite and PortletRegistrySuite before run this suite";
  
  public UserContentBrowseSuite() {    
    super(NAME, DESC) ;    
    goToPage("/home");
    addWebUnit(CommonUnit.createClickEditPageMode()) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnAddPortlet", "Click on Add Portlet icon").
        setURL("portal:componentId=news&portal:action=addPortlet").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPortletSelecttor&op=selecCategory&objectId=cms-content"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOn'cms-content'category", "Expand Cms-Content category").
        setURL("uicomponent=UIPortletSelecttor&op=selecCategory&objectId=cms-content").   
        addCondition(new NoLinkWithURLCondition("uicomponent=UIPortletSelecttor&op=selecPortlet&objectId=cms-content/ContentBrowser")).
        addValidator(new ExpectTextValidator("ContentBrowser"))
    ) ;           
    //-----Selete a portlet in expanded content category
    addWebUnit(
        new ClickURLLinkUnit("ContentBrowser'portlet", "Select the Content Browser portlet").      
        setURL("uicomponent=UIPortletSelecttor&op=selecPortlet&objectId=cms-content/ContentBrowser").
        addValidator(new ExpectLinkWithURLValidator("portal:componentId=news&portal:action=changeTab&objectId=ContentBrowser"))        
    ) ;
    addWebUnit( CommonUnit.createClickSavePage()) ;
    addWebUnit( CommonUnit.createClickViewMode()) ;    
    addWebUnit(
        new ClickURLLinkUnit("ClickContentBrowser", "Click on ContentBrowser tab").
        setURL("portal:componentId=news&portal:action=changeTab&objectId=ContentBrowser").                
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentList&op=viewCategory&objectId=/jcr:system/exo:ecm/exo:taxonomies/cms"))
    ) ;      
    //-----Login with demo account
    addWebUnit(
      new ContextManagementUnit(ContextManagementUnit.SAVE, "Save Context")
    ); 
    String[] roles=["user"];
    addWebSuite(new UserLoginSuite("demo", "exo", roles)) ;    
    goToPage("/Site Map/ecm") ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnProduction", "click on Production button").
        setURL("&uicomponent=UIWorkspaceBrowser&op=selectWorkspace&objectId=production").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=selectWorkspace"))      
    ) ; 
    //Select view
    addWebUnit(
      new SubmitFormUnit("SelectCreatedNewView", "select created new view").
      setFormId("UISelectViewForm").              
      setField("views","view-test").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIViewController&op=selectNode&objectId=Admin"))      
    ) ;  
    //-----Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").               
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addFolder"))      
    ) ; 
    //-----Goto /home/users/demo
   addWebUnit(
      new ClickURLLinkUnit("ClickOnHome", "click on home link").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users"))     
    ) ; 
    addWebUnit(
      new ClickURLLinkUnit("ClickOnUsers", "click on users link").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/demo"))      
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("ClickOnCurrentUser", "click on current user link").
      setURL("uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/demo")
    ) ;
    //-----Delete test-folder if does exist
    addWebUnit(
      new ClickURLLinkUnit("DeleteExistedFolder", "Delete if test-folder is existed").
      setURL("&uicomponent=UIDocumentInfo&op=removeNode&objectId=/home/users/demo/test-folder").
      addCondition(new HaveLinkWithTextCondition("test-folder")).
      addValidator(new ExpectTextValidator("The node /home/users/demo/test-folder has been removed."))
    ) ;        
    //-----Add folder directory
    addWebUnit(
      new ClickURLLinkUnit("ClickOnAddFolder", "click on Add Folder button").
      setURL("&uicomponent=UIToolbar&op=addFolder").                  
      addValidator(new ExpectFormIdValidator("folderForm"))      
    ) ;    
    //----------Add nt:unstructured folder
    addWebUnit(
      new SubmitFormUnit("AddNewFolder", "Select type is nt:unstructured and click on Save button").
      setFormId("folderForm").   
      setField("type","nt:unstructured").
      setField("name","test-folder").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/demo/test-folder"))      
    ) ;   
    //-----Go to test-folder
    addWebUnit(
      new ClickURLLinkUnit("GotoTest-folder", "click on test-folder").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/demo/test-folder").         
      addValidator(new ExpectTextValidator(">")).
      addValidator(new ExpectTextValidator("test-folder"))
    ) ;  
    //-----Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;   
    //-----Refresh session
    addWebUnit(
      new ClickURLLinkUnit("RefreshSession", "click on Refresh Session button").
      setURL("&uicomponent=MainToolbar&op=refreshSession").  
      addValidator(new ExpectTextValidator("The session has been refreshed successfuly"))      
    ) ;           
    //Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addFolder"))      
    ) ;
    //Click on Add document
    addWebUnit(
      new ClickURLLinkUnit("AddDocument", "click on Add Document button").
      setURL("uicomponent=UIToolbar&op=addDocument").    
      addValidator(new ExpectFormIdValidator("selectDocumentForm")).
      addValidator(new ExpectFormIdValidator("documentForm"))
    ) ;
    //-----Add new Nt:file document
    addWebUnit(
      new SubmitFormUnit("SelectDocumentType", "select document type is nt:file").
      setFormId("selectDocumentForm").   
      setField("documentType","nt:file").
      setField("op","changeDocument").
      addValidator(new ExpectNoTextValidator("Image to upload")).
      addValidator(new ExpectTextValidator("File")).
      addValidator(new ExpectTextValidator("Content:"))
    ) ;
    //----------Save New Document
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("documentForm").   
      setField("docName","test-doc").
      setField("summary","content").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=editDocument&objectId=/home/users/demo/test-folder/test-doc"))
    ) ;          
    //Click on Add document
    addWebUnit(
      new ClickURLLinkUnit("AddDocument", "click on Add Document button").
      setURL("uicomponent=UIToolbar&op=addDocument").    
      addValidator(new ExpectFormIdValidator("selectDocumentForm")).
      addValidator(new ExpectFormIdValidator("documentForm"))
    ) ;
    //-----Add new Nt:file document
    addWebUnit(
      new SubmitFormUnit("SelectDocumentType", "select document type is nt:file").
      setFormId("selectDocumentForm").   
      setField("documentType","exo:article").
      setField("op","changeDocument").
      addValidator(new ExpectTextValidator("Image to upload"))
    ) ;
    //----------Save New Document
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("documentForm").   
      setField("docName","test-doc").
      setField("title","title").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=editDocument&objectId=/home/users/demo/test-folder/test-doc"))
    ) ;      
    //Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;    
    //-----Back to current user
    addWebUnit(
      new ContextManagementUnit(ContextManagementUnit.RESTORE, "Restore Context")
    );     
    goToPage("/home");
    //*Check some actions search
    addWebUnit(
        new ClickURLLinkUnit("ClickOnSearchIcon", "Click on search icon").
        setURL("uicomponent=MainToolbar&op=search").   
          addValidator(new ExpectFormIdValidator("UISearchForm"))
    ) ;
   addWebUnit(
        new SubmitFormUnit("SearchNotExistCategory", "search with not exist category").
        setFormId("UISearchForm").   
        setField("type","Category").
        setField("keyword","notExistCategory").
        setField("op","searchAction").                  
        addValidator(new ExpectTextValidator("No result"))      
    ) ;
    addWebUnit(
        new SubmitFormUnit("SearchChildCategory", "search with exist childCategory").
        setFormId("UISearchForm").   
        setField("type","Category").
        setField("keyword","childCategory").
        setField("op","searchAction").                  
        addValidator(new ExpectTextValidator("childCategory")).      
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIResults&op=changeNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnPathchildCategory", "Click on path of searched childCategory").
        setURL("uicomponent=UIResults&op=changeNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/newCategory/childCategory").                  
        addValidator(new ExpectTextValidator("childCategory"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnSearchIcon", "Click on search icon").
        setURL("uicomponent=MainToolbar&op=search").                  
        addValidator(new ExpectFormIdValidator("UISearchForm"))
    ) ;
    //*Check some actions of pathconfig
    //-----pathconfig
    addWebUnit(
        new ClickURLLinkUnit("ClickOnEditIcon", "Click on edit icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=edit").                  
        addValidator(new ExpectFormIdValidator("PathConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnEditConfigIcon", "Click on 'Edit config' icon").
        setFormId("PathConfig").   
        setField("op","editConfig").                  
        addValidator(new ExpectFormIdValidator("PathConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnSaveIcon", "click on Save icon").
        setFormId("PathConfig").   
        setField("path","/home/users/demo").
        setField("op","save").
        addValidator(new ExpectTextValidator("Save successfully"))
    ) ;    
    addWebUnit(
        new ClickURLLinkUnit("ClickOnViewIcon", "Click on View icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=view").                  
        addValidator(new ExpectTextValidator("Category "))
    ) ;    
    addWebUnit(
      new ClickURLLinkUnit("ClickOnSearchIcon", "Click on search icon").
      setURL("&uicomponent=MainToolbar&op=search").                  
      addValidator(new ExpectFormIdValidator("UISearchForm"))
    ) ;    
    addWebUnit(
      new SubmitFormUnit("Searchtest-docTitle", "search with exist title test-doc").
      setFormId("UISearchForm").   
      setField("type","Content").
      setField("keyword","title").
      setField("op","searchAction").                  
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIResults&op=changeNode&objectId=/home/users/demo/test-folder/test-doc[2]"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("Searchtest-docContent", "search with exist content test-doc").
        setFormId("UISearchForm").   
        setField("type","Content").
        setField("keyword","content").
        setField("op","searchAction").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIResults&op=changeNode&objectId=/home/users/demo/test-folder/test-doc"))
    ) ;
    //-----test-path
    addWebUnit(
        new ClickURLLinkUnit("ClickOnEditIcon", "Click on edit icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=edit").                  
        addValidator(new ExpectFormIdValidator("PathConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnEditConfigIcon", "Click on 'Edit config' icon").
        setFormId("PathConfig").   
        setField("op","editConfig").                  
        addValidator(new ExpectFormIdValidator("PathConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnSaveIcon", "click on Save icon").
        setFormId("PathConfig").   
        setField("path","/home/users/demo").
        setField("template","test-path").
        setField("op","save").
        addValidator(new ExpectTextValidator("Save successfully"))
    ) ;    
    addWebUnit(
        new ClickURLLinkUnit("ClickOnViewIcon", "Click on View icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=view").                  
        addValidator(new ExpectTextValidator("test-path"))
    ) ;     
    //*Check some actions of query config
    //-----query config by xpath
    addWebUnit(
        new ClickURLLinkUnit("ClickOnEditIcon", "Click on edit icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=edit").                  
        addValidator(new ExpectFormIdValidator("PathConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnNewConfig", "Click on 'New Config' icon").
        setFormId("PathConfig").   
        setField("op","newConfig").
        addValidator(new ExpectFormIdValidator("NewConfigForm"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("SubmitQueryConfig", "Submit query config").
        setFormId("NewConfigForm").   
        setField("workspace","production").
        setField("usecase","Using a JCR query").
        setField("op","save").
        addValidator(new ExpectFormIdValidator("QueryConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("SaveXpathQuery", "click on save xpath query").
        setFormId("QueryConfig").   
        setField("queryLanguage","xpath").
        setField("queryStatement","/jcr:root/home/users/demo//element(*, exo:article)").
        setField("template","QueryList").
        setField("op","save").
        addValidator(new ExpectTextValidator("Save successfully"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnViewIcon", "Click on view icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=view").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentList&op=viewDocument&objectId=production:/home/users/demo/test-folder/test-doc[2]"))
    ) ;      
    //-----query config by sql
    addWebUnit(
        new ClickURLLinkUnit("ClickOnEditIcon", "Click on edit icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=edit").                  
        addValidator(new ExpectFormIdValidator("QueryConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnEditConfigIcon", "Click on 'Edit config' icon").
        setFormId("QueryConfig").   
        setField("op","editConfig").                  
        addValidator(new ExpectFormIdValidator("QueryConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("SaveSQLQuery", "click on save sql query").
        setFormId("QueryConfig").   
        setField("queryLanguage","sql").
        setField("queryStatement","select * from exo:article where jcr:path like '/home/users/demo/%'").
        setField("template","QueryList").
        setField("op","save").
        addValidator(new ExpectTextValidator("Save successfully"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnViewIcon", "Click on view icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=view").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentList&op=viewDocument&objectId=production:/home/users/demo/test-folder/test-doc[2]"))
    ) ;
    //-----test-query
    addWebUnit(
        new ClickURLLinkUnit("ClickOnEditIcon", "Click on edit icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=edit").                  
        addValidator(new ExpectFormIdValidator("QueryConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnEditConfigIcon", "Click on 'Edit config' icon").
        setFormId("QueryConfig").   
        setField("op","editConfig").                  
        addValidator(new ExpectFormIdValidator("QueryConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("SaveXpathQuery", "click on save xpath query").
        setFormId("QueryConfig").   
        setField("queryLanguage","xpath").
        setField("queryStatement","/jcr:root/home/users/demo//element(*, exo:article)").
        setField("template","test-query").
        setField("op","save").
        addValidator(new ExpectTextValidator("Save successfully"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnViewIcon", "Click on view icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=view").                  
        addValidator(new ExpectTextValidator("test-query"))
    ) ;   
    //*Check some actions of script config 
    addWebUnit(
        new ClickURLLinkUnit("ClickOnEditIcon", "Click on edit icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=edit").                  
        addValidator(new ExpectFormIdValidator("QueryConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnNewConfig", "Click on 'New Config' icon").
        setFormId("QueryConfig").   
        setField("op","newConfig").
        addValidator(new ExpectFormIdValidator("NewConfigForm"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("SubmitScriptConfig", "Submit script config").
        setFormId("NewConfigForm").   
        setField("workspace","production").
        setField("usecase","Using a script").
        setField("op","save").
        addValidator(new ExpectFormIdValidator("ScriptConfigForm"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnSaveIcon", "click on save icon").
        setFormId("ScriptConfigForm").   
        setField("scriptList","content-browser/GetDocumentsFromWorkspaceAndPath.groovy").
        setField("template","ScriptList").
        setField("path","/home/users/demo").
        setField("op","save").
        addValidator(new ExpectTextValidator("Save successfully"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnViewIcon", "Click on view icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=view").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentList&op=viewCategory&objectId=/home/users/demo/test-folder"))
    ) ;   
    //-----test-script
    addWebUnit(
        new ClickURLLinkUnit("ClickOnEditIcon", "Click on edit icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=edit").                  
        addValidator(new ExpectFormIdValidator("ScriptConfigForm"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnEditConfigIcon", "Click on 'Edit config' icon").
        setFormId("ScriptConfigForm").   
        setField("op","editConfig").                  
        addValidator(new ExpectFormIdValidator("ScriptConfigForm"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnSaveIcon", "click on save icon").
        setFormId("ScriptConfigForm").   
        setField("scriptList","content-browser/GetDocumentsFromWorkspaceAndPath.groovy").
        setField("template","test-script").
        setField("path","/home/users/demo").
        setField("op","save").
        addValidator(new ExpectTextValidator("Save successfully"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnViewIcon", "Click on view icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=view").                  
        addValidator(new ExpectTextValidator("test-script"))
    ) ; 
    //*Check some actions of document config
    addWebUnit(
        new ClickURLLinkUnit("ClickOnEditIcon", "Click on edit icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=edit").                  
        addValidator(new ExpectFormIdValidator("ScriptConfigForm"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnNewConfig", "Click on 'New Config' icon").
        setFormId("ScriptConfigForm").   
        setField("op","newConfig").
        addValidator(new ExpectFormIdValidator("NewConfigForm"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("SubmitDocumentConfig", "Submit document config").
        setFormId("NewConfigForm").   
        setField("workspace","production").
        setField("usecase","Document").
        setField("op","save").
        addValidator(new ExpectFormIdValidator("DocumentConfig"))
    ) ;   
    addWebUnit(
        new SubmitFormUnit("SaveWithPathEmpty", "Save with path field empty").
        setFormId("DocumentConfig").   
        setField("path"," ").
        setField("documentName"," ").
        setField("op","save").
        addValidator(new ExpectTextValidator("A Repository Exception occured."))
    ) ;
    addWebUnit(
        new SubmitFormUnit("SaveWithDocumentNameEmpty", "Save with document name field empty").
        setFormId("DocumentConfig").   
        setField("path","/home/users/demo/test-folder").
        setField("documentName","").
        setField("op","save").
        addValidator(new ExpectTextValidator("Item not found."))
    ) ;
    addWebUnit(
        new SubmitFormUnit("SaveWithDon'tExistedDocument", "Save with documentName field is not existed document").
        setFormId("DocumentConfig").   
        setField("path","/home/users/demo/test-folder").
        setField("documentName","false-test-doc").
        setField("op","save").
        addValidator(new ExpectTextValidator("Path not found."))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnSaveIcon", "click on save icon").
        setFormId("DocumentConfig").   
        setField("path","/home/users/demo/test-folder").
        setField("documentName","test-doc").
        setField("op","save").
        addValidator(new ExpectTextValidator("Save successfully"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnViewIcon", "Click on view icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=view").                  
        addValidator(new ExpectTextValidator("content"))
    ) ;    
    //-----test-document
    addWebUnit(
        new ClickURLLinkUnit("ClickOnEditIcon", "Click on edit icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=edit").                  
        addValidator(new ExpectFormIdValidator("DocumentConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnEditConfigIcon", "Click on 'Edit config' icon").
        setFormId("DocumentConfig").   
        setField("op","editConfig").                  
        addValidator(new ExpectFormIdValidator("DocumentConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnSaveIcon", "click on save icon").
        setFormId("DocumentConfig").   
        setField("path","/home/users/demo/test-folder").
        setField("documentName","test-doc").
        setField("boxTemplate","test-detailView").
        setField("op","save").
        addValidator(new ExpectTextValidator("Save successfully"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnViewIcon", "Click on view icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=view").                  
        addValidator(new ExpectTextValidator("test-detailView"))
    ) ;   
    //*    
    addWebUnit(
        new ClickURLLinkUnit("ClickOnEditIcon", "Click on edit icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=edit").                  
        addValidator(new ExpectFormIdValidator("DocumentConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnNewConfig", "Click on 'New Config' icon").
        setFormId("DocumentConfig").   
        setField("op","newConfig").
        addValidator(new ExpectFormIdValidator("NewConfigForm"))
    ) ;    
    addWebUnit(
        new SubmitFormUnit("SubmitConfig", "Submit query config").
        setFormId("NewConfigForm").   
        setField("workspace","production").
        setField("usecase","Form Path").
        setField("op","save").
        addValidator(new ExpectFormIdValidator("PathConfig"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnSaveIcon", "click on Save icon").
        setFormId("PathConfig").   
        setField("path","/jcr:system/exo:ecm/exo:taxonomies").
        setField("template","PathList").
        setField("op","save").
        addValidator(new ExpectTextValidator("Save successfully"))
    ) ;  
    addWebUnit(
        new ClickURLLinkUnit("ClickOnViewIcon", "Click on view icon").
        setURL("portal:componentId=ContentBrowser&portal:portletMode=view").                  
        addValidator(new ExpectTextValidator("Category "))
    ) ;    
    //-----Login with demo account
    addWebUnit(
      new ContextManagementUnit(ContextManagementUnit.SAVE, "Save Context")
    ); 
    addWebSuite(new UserLoginSuite("demo", "exo", roles)) ;    
    goToPage("/Site Map/ecm") ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnProduction", "click on Production button").
        setURL("&uicomponent=UIWorkspaceBrowser&op=selectWorkspace&objectId=production").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=selectWorkspace"))      
    ) ; 
    //Select view
    addWebUnit(
      new SubmitFormUnit("SelectCreatedNewView", "select created new view").
      setFormId("UISelectViewForm").            
      setField("views","view-test").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIViewController&op=selectNode&objectId=Admin"))      
    ) ;  
    //-----Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").               
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addFolder"))      
    ) ; 
    //-----Goto /home/users/demo
   addWebUnit(
      new ClickURLLinkUnit("ClickOnHome", "click on home link").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users"))     
    ) ; 
    addWebUnit(
      new ClickURLLinkUnit("ClickOnUsers", "click on users link").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/demo"))      
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("ClickOnCurrentUser", "click on current user link").
      setURL("uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/demo")
    ) ;
    //-----Go to test-folder
    addWebUnit(
      new ClickURLLinkUnit("GotoTest-folder", "click on test-folder").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/demo/test-folder").         
      addValidator(new ExpectTextValidator(">")).
      addValidator(new ExpectTextValidator("test-folder"))
    ) ;     
    addWebUnit(
      new ClickURLLinkUnit("Deletetest-doc", "Delete test-doc of nt:file").
      setURL("uicomponent=UIDocumentInfo&op=removeNode&objectId=/home/users/demo/test-folder/test-doc").                  
      addValidator(new ExpectTextValidator("The node /home/users/demo/test-folder/test-doc has been removed."))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("Deletetest-doc", "Delete test-doc of exo:article").
        setURL("uicomponent=UIDocumentInfo&op=removeNode&objectId=/home/users/demo/test-folder/test-doc").      
        addValidator(new ExpectTextValidator("The node /home/users/demo/test-folder/test-doc has been removed."))
    ) ;
    //Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    addWebSuite(new UserLogoutSuite()) ;
    //----Back to current user
    addWebUnit(
      new ContextManagementUnit(ContextManagementUnit.RESTORE, "Restore Context")
    );        
    //Return to workspace selection
    addWebUnit(
        new ClickLinkWithText("ClickOnECM", "Go to ECM").
        setTextLink("ECM").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIWorkspaceBrowser&op=selectWorkspace&objectId=production"))
    ) ;     
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}
