/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * June 27, 2006
 */
public class UserExportNodeSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, select Admin tab, click on UserExportNodeSuite button and test all the basic actions" ;
  static String NAME = "UserExportNodeSuite" ;
  String COMMENT  = "You must run AdminViewSuite before run this suite";
  
  public UserExportNodeSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTab", "click on Admin tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Admin").             
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=exportNode"))      
    ) ;  
    addWebUnit(
      new ClickURLLinkUnit("ClickOnExportNodeButton", "click on export node button").
      setURL("&uicomponent=UIToolbar&op=exportNode").                   
      addValidator(new ExpectFormIdValidator("uiExport"))
    ) ;
    addWebUnit(
      new SubmitFormUnit("ClickOnCancel", "click on cancel button").
      setFormId("uiExport").
      setField("op","PhaseId[1].cancel").
      addValidator(new ExpectNoTextValidator("Path to Export"))      
    ) ;
    //Select Workspace
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ; 
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}