/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;


/**
 * Test copy, cut and paste actions on newly created documents. This Suite
 * depends on the AddDocumentSuite one.      
 *     1) Create /test-folder directory
 *     2) Create /test-folder/test-doc
 *     3) Lock action
 			 4) Unlock action
 *     5) Go back to workspaces selection page
 *
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserLockUnlockNodeSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, click on test-folder and to do somethings" ;
  static String NAME = "UserLockUnlockNodeSuite" ;
    
  public UserLockUnlockNodeSuite() {    
    super(NAME, DESC) ;   
    addWebSuite(new UserAddFolderSuite());        
    //Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addDocument"))      
    ) ;
    
    //Click on Add document
    addWebUnit(
      new ClickURLLinkUnit("AddDocument", "click on Add Document button").
      setURL("uicomponent=UIToolbar&op=addDocument").    
      addValidator(new ExpectFormIdValidator("selectDocumentForm")).
      addValidator(new ExpectFormIdValidator("documentForm"))
    ) ;
    
    //-----Add new Nt:file document
    addWebUnit(
      new SubmitFormUnit("SelectNt:fileType", "select document type is nt:file").
      setFormId("selectDocumentForm").   
      setField("documentType","nt:file").
      setField("op","changeDocument").
      addValidator(new ExpectNoTextValidator("Article"))      
    ) ;
    
    //----------Save New Document
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("documentForm").   
      setField("docName","test-doc").
      setField("summary","content").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIDocumentInfo&op=editDocument&objectId=/home/users/#{client.name}/test-folder/test-doc"))                                                   
    ) ;                
    
    //Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    
    // ----- Lock test-doc
    addWebUnit(
      new ClickURLLinkUnit("Lock test-doc", "click lock action").
      setURL("&uicomponent=UIDocumentInfo&op=lock&objectId=/home/users/#{client.name}/test-folder/test-doc").        
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=unlock&objectId=/home/users/#{client.name}/test-folder/test-doc"))
    ) ;
    
    // ------Unlock test-doc
    addWebUnit(
      new ClickURLLinkUnit("UnLock test-doc", "click Unlock action").
      setURL("&uicomponent=UIDocumentInfo&op=unlock&objectId=/home/users/#{client.name}/test-folder/test-doc").        
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=lock&objectId=/home/users/#{client.name}/test-folder/test-doc"))
    ) ;
    
    //Return to workspace selection
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces"))      
    ) ;    
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}