/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL 
 * Author : Hoa Nguyen Thi
 *          hoa2501@yahoo.com
 * May 30, 2006
 */
public class UserMacViewSuite extends WebUnitSuite {
  static String DESC = "Go to ECM and test some basic actions with type view is mac-view" ;
  static String NAME = "UserMacViewSuite" ;
  public UserMacViewSuite() {    
    super(NAME, DESC) ;    
    goToPage("/Site Map/ecm") ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnProduction", "click on Production button").
        setURL("&uicomponent=UIWorkspaceBrowser&op=selectWorkspace&objectId=production").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=selectWorkspace"))      
    ) ; 
    //Select view
    addWebUnit(
      new SubmitFormUnit("SelectMacView", "select mac view").
      setFormId("UISelectViewForm").            
      setField("views","mac-view").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIViewController&op=selectNode&objectId=Actions"))      
    ) ;  
    //-----Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").               
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addFolder"))      
    ) ; 
    //-----Goto /home/users/#{client.name}
   addWebUnit(
      new ClickURLLinkUnit("ClickOnHome", "click on home link").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users"))     
    ) ; 
    addWebUnit(
      new ClickURLLinkUnit("ClickOnUsers", "click on users link").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/#{client.name}"))      
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("ClickOnCurrentUser", "click on current user link").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/#{client.name}")
    ) ;
    //-----Delete test-folder if does exist
    addWebUnit(
      new ClickURLLinkUnit("DeleteExistedFolder", "Delete if new-folder is existed").
      setURL("&uicomponent=UIDocumentInfo&op=removeNode&objectId=/home/users/#{client.name}/new-folder").
      addCondition(new HaveLinkWithTextCondition("new-folder")).
      addValidator(new ExpectTextValidator("The node /home/users/#{client.name}/new-folder has been removed."))
    ) ;        
    //-----Add folder directory
    addWebUnit(
      new ClickURLLinkUnit("ClickOnAddFolder", "click on Add Folder button").
      setURL("&uicomponent=UIToolbar&op=addFolder").                  
      addValidator(new ExpectFormIdValidator("folderForm"))      
    ) ;    
    //----------Add nt:unstructured folder
    addWebUnit(
      new SubmitFormUnit("AddNewFolder", "Select type is nt:unstructured and click on Save button").
      setFormId("folderForm").   
      setField("type","nt:unstructured").
      setField("name","new-folder").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/#{client.name}/new-folder"))      
    ) ;   
    //-----Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;   
    //-----Go to test-folder
    addWebUnit(
      new ClickURLLinkUnit("Gotonew-folder", "click on new-folder").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/home/users/#{client.name}/new-folder").         
      addValidator(new ExpectTextValidator(">")).
      addValidator(new ExpectTextValidator("new-folder"))
    ) ;  
    //Click on Add document
    addWebUnit(
      new ClickURLLinkUnit("AddDocument", "click on Add Document button").
      setURL("uicomponent=UIToolbar&op=addDocument").    
      addValidator(new ExpectFormIdValidator("selectDocumentForm")).
      addValidator(new ExpectFormIdValidator("documentForm"))
    ) ;
    //-----Add new Nt:file document
    addWebUnit(
      new SubmitFormUnit("SelectDocumentType", "select document type is exo:article").
      setFormId("selectDocumentForm").   
      setField("documentType","nt:file").
      setField("op","changeDocument").
      addValidator(new ExpectFormIdValidator("documentForm"))
    ) ;
    //----------Save New Document
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("documentForm").   
      setField("docName","test-doc").
      setField("summary","content").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIDocumentInfo&op=editDocument&objectId=/home/users/#{client.name}/new-folder/test-doc"))                                                   
    ) ;                
    //Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    //Test action edit of test-doc
    addWebUnit(
        new ClickURLLinkUnit("ClickEditTest-doc", "click on edit icon of test-doc").
        setURL("uicomponent=UIDocumentInfo&op=editDocument&objectId=/home/users/#{client.name}/new-folder/test-doc").        
        addValidator(new ExpectFormIdValidator("uiResourceForm"))      
    ) ;
    addWebUnit(
        new SubmitFormUnit("SubmitEditDocument", "click on save button").
        setFormId("uiResourceForm").   
        setField("name","test-doc").
        setField("text","updated-content").      
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIDocumentInfo&op=editDocument&objectId=/home/users/#{client.name}/new-folder/test-doc"))                                                   
    ) ;
    //Test action copy for test-doc
    addWebUnit(
        new ClickURLLinkUnit("ClickCopyTest-doc", "click on copy icon of test-doc").
        setURL("uicomponent=UIDocumentInfo&op=copy&objectId=/home/users/#{client.name}/new-folder/test-doc").        
        addValidator(new ExpectTextValidator("The node /home/users/#{client.name}/new-folder/test-doc has been copied."))      
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickParseTest-doc", "click on parse icon of test-doc").
        setURL("uicomponent=UIToolbar&op=paste").        
        addValidator(new ExpectTextValidator("The node /home/users/#{client.name}/new-folder/test-doc has been pasted at the location /home/users/#{client.name}/new-folder/test-doc. This operation has already been save and you do not need to press the floppy icon."))      
    ) ;
    //Test action cut
    addWebUnit(
        new ClickURLLinkUnit("ClickCutTest-doc", "click on cut icon of test-doc").
        setURL("uicomponent=UIDocumentInfo&op=cut&objectId=/home/users/#{client.name}/new-folder/test-doc").        
        addValidator(new ExpectTextValidator("The node /home/users/#{client.name}/new-folder/test-doc has been cut."))      
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("GoToCurrentUser", "click on current user link").
        setURL("uicomponent=UIJCRExplorer&op=changeNode&objectId=/home/users/#{client.name}").        
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIToolbar&op=paste"))      
    ) ;   
    addWebUnit(
        new ClickURLLinkUnit("ClickParseTest-doc", "click on parse icon of test-doc").
        setURL("uicomponent=UIToolbar&op=paste").        
        addValidator(new ExpectTextValidator("The node /home/users/#{client.name}/new-folder/test-doc has been pasted at the location /home/users/#{client.name}/test-doc. This operation has already been save and you do not need to press the floppy icon."))      
    ) ;
    //Test action delete
    addWebUnit(
        new ClickURLLinkUnit("ClickDeleteTest-doc", "click on delete icon of test-doc").
        setURL("uicomponent=UIDocumentInfo&op=removeNode&objectId=/home/users/#{client.name}/test-doc").        
        addValidator(new ExpectTextValidator("The node /home/users/#{client.name}/test-doc has been removed."))      
    ) ;
    //Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    //Return to workspace selection
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ; 
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}