/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserViewNodeTypesSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User, select Info tab, select View Node Types and to do somethings" ;
  static String NAME = "UserViewNodeTypesSuite" ;
  
  public UserViewNodeTypesSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());
    //-----Select Info tab
    addWebUnit(
      new ClickURLLinkUnit("SelectInfoTab", "click on info tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Info").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewNodeType"))      
    ) ;
    
    //-----View Node Type
    addWebUnit(
      new ClickURLLinkUnit("ClickOnViewNodeType", "click on View Node Type button").
      setURL("&uicomponent=UIToolbar&op=viewNodeType").  
      addValidator(new ExpectTextValidator("Node Type")).      
      addValidator(new ExpectTextValidator("Node Property Definition")).            
      addValidator(new ExpectTextValidator("Child Node Definition"))      
    ) ;    
    
    //Back to previous node
    addWebUnit(
      new ClickURLLinkUnit("BackToPreviousNode", "back to previous node").
      setURL("&uicomponent=UINodeTypeInfo&op=PhaseId[1].cancel")          
    ) ; 
    
    //Select Workspace
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ;    
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}