/**************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved. *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package suites.iframe;

import condition.* ;
import suites.share.* ;
import suites.share.UserLoginSuite;
import suites.share.UserLogoutSuite;
import suites.admin.*;

import org.exoplatform.test.*;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          jobdung@yahoo.com
 * June 28, 2006
 */
public class IframePortletUserSuite extends WebUnitSuite {
  String COMMENT  = "You must run PortletRegistrySuite suite before run this suite";
  public IframePortletUserSuite() {
    super("IframePortletUserSuite", "Add a new iframe portlet to home page and test some basic functions") ;    
    addWebUnit(CommonUnit.createClickEditPageMode()) ;         
    //Add a new iframe portlet
    addWebUnit(
      new ClickURLLinkUnit("ClickOnAddPortlet", "Click on add portlet on home page").
      setURL("portal:componentId=page&portal:action=addPortlet").                
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPortletSelecttor&op=selecCategory&objectId=web"))      
    ) ;
    addWebSuite(new AddPortletSuite("web","IFramePortlet")) ;    
    //Save page and edit iframe portlet
    addWebUnit(
      new ClickURLLinkUnit("ClickOnSavePageButton", "Click on save page button").
      setURL("&uicomponent=UIToolbarPage&op=savePage").   
      addValidator(new ExpectTextValidator("Portlet:IFramePortlet")).      
      addValidator(new ExpectLinkWithURLValidator("?portal:componentId=IFramePortlet&portal:portletMode=edit"))
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("ClickOnPortletEditMode", "Click on portlet edit mode button of IFramePortlet").
      setURL("?portal:componentId=IFramePortlet&portal:portletMode=edit").      
      addValidator(new ExpectFormIdValidator("UIIFramePreferencesForm"))
    ) ;
    //Change iframe-src and check view content
    addWebUnit(
      new SubmitFormUnit("SubmitForm", "submit the page's form with the new property values").
      setFormId("UIIFramePreferencesForm").        
      setField("iframe-width", "*").
      setField("iframe-height", "*").
      setField("iframe-src","/web/iframe-portlet-test.html").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("?portal:componentId=IFramePortlet&portal:portletMode=view"))
    );
    addWebUnit(
      new ClickURLLinkUnit("ClickOnPortletViewMode", "Click on portlet view mode button of IFramePortlet").
      setURL("?portal:componentId=IFramePortlet&portal:portletMode=view").    
      addValidator(new ExpectLinkWithURLValidator("?portal:componentId=IFramePortlet&portal:portletMode=edit")).
      addValidator(new ExpectTextValidator("iframe-portlet-test.html"))         
    ) ;
    //Remove iframe portlet
    addWebUnit(
      new ClickURLLinkUnit("RemoveIFramePortlet", "Click on portlet remove porlet button of IFramePortlet").
      setURL("?portal:componentId=IFramePortlet&portal:action=delete").      
      addValidator(new ExpectLinkWithURLValidator("?portal:componentId=IFramePortlet&portal:portletMode=edit",0))
    ) ;
    //Resave page
    addWebUnit(
      new ClickURLLinkUnit("ClickOnSavePageButton", "Click on save page button").
      setURL("&uicomponent=UIToolbarPage&op=savePage")      
    ) ;
    //Back to view page and logout  
    addWebUnit(CommonUnit.createClickViewMode()) ;          
  }  
  public java.util.List getRequiredSuites() {         
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ; 
  } 
}