/**************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved. *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package suites.rss;

import condition.* ;
import suites.share.* ;
import suites.share.UserLoginSuite;
import suites.share.UserLogoutSuite;
import suites.admin.*;

import org.exoplatform.test.*;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          jobdung@yahoo.com
 * June 28, 2006
 */
public class RssPortletUserSuite extends WebUnitSuite {
  String COMMENT  = "You must run PortletRegistrySuite suite before run this suite";
  public RssPortletUserSuite() {
    super("RssPortletUserSuite", "Add a new Rss portlet to home page and test some basic functions") ;    
    addWebUnit(CommonUnit.createClickEditPageMode()) ;         
    //Add a new Rss portlet
    addWebUnit(
      new ClickURLLinkUnit("ClickOnAddPortlet", "Click on add portlet on home page").
      setURL("portal:componentId=page&portal:action=addPortlet").                
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPortletSelecttor&op=selecCategory&objectId=web"))      
    ) ;
    addWebSuite(new AddPortletSuite("web","Rss_Portlet")) ;    
    //Save page and edit Rss portlet
    addWebUnit(
      new ClickURLLinkUnit("ClickOnSavePageButton", "Click on save page button").
      setURL("&uicomponent=UIToolbarPage&op=savePage").   
      addValidator(new ExpectTextValidator("Project EXO Portal / CMS / LMS")).      
      addValidator(new ExpectLinkWithURLValidator("?portal:componentId=Rss_Portlet&portal:portletMode=edit"))
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("ClickOnPortletEditMode", "Click on portlet edit mode button of RssPortlet").
      setURL("?portal:componentId=Rss_Portlet&portal:portletMode=edit").      
      addValidator(new ExpectFormIdValidator("UIRssPreferencesForm"))
    ) ;
    //Change url and check view content
    addWebUnit(
      new SubmitFormUnit("SubmitForm", "submit the page's form with the new property values").
      setFormId("UIRssPreferencesForm").        
      setField("description", "This is the news from internet").
      setField("url", "/exo-rss-test.xml").
      setField("channel","News").
      setField("item-to-show","5").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("?portal:componentId=Rss_Portlet&portal:portletMode=view"))
    );
    addWebUnit(
      new ClickURLLinkUnit("ClickOnPortletViewMode", "Click on portlet view mode button of RssPortlet").
      setURL("?portal:componentId=Rss_Portlet&portal:portletMode=view").    
      addValidator(new ExpectLinkWithURLValidator("?portal:componentId=Rss_Portlet&portal:portletMode=edit")).
      addValidator(new ExpectLinkWithURLValidator("http://sourceforge.net/projects/exo/test/"))         
    ) ;
    //Remove Rss portlet
    addWebUnit(
      new ClickURLLinkUnit("RemoveRssPortlet", "Click on portlet remove porlet button of RssPortlet").
      setURL("?portal:componentId=Rss_Portlet&portal:action=delete").      
      addValidator(new ExpectLinkWithURLValidator("?portal:componentId=Rss_Portlet&portal:portletMode=edit",0))
    ) ;
    //Resave page
    addWebUnit(
      new ClickURLLinkUnit("ClickOnSavePageButton", "Click on save page button").
      setURL("&uicomponent=UIToolbarPage&op=savePage")      
    ) ;
    //Back to view page and logout  
    addWebUnit(CommonUnit.createClickViewMode()) ;      
    addWebSuite(new UserLogoutSuite()) ;
  }  
  public java.util.List getRequiredSuites() {         
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ; 
  } 
}