/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.user;

import condition.* ;
import suites.share.*;
import suites.share.UserLoginSuite;
import suites.share.NewAccountSuite;
import suites.share.ViewUserProfileSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Hoa Nguyen Thi
 *          hoanguyen@exoplatform.com, hoa2501@yahoo.com
 * Mar 13, 2005
 */
public class CreateMultiUserSuite extends WebUnitSuite {
  static String DESC = "Create multi user account" ;
  static String NAME = "CreateMultiUserSuite" ;
  final static public String USER_ACCOUNT = "user" ;
  final static public int AMOUNT = 30 ;
    
  public CreateMultiUserSuite() {    
    super(NAME, DESC) ;
    init("/Site Map/Management", "/Site Map/Add User") ;
  }  
  public CreateMultiUserSuite(String path, String reg_path) {
    super(NAME, DESC) ;
    init(path, reg_path) ;
  }  
  public void  init(path, reg_path) {    
    goToPage(path) ; 
    addWebUnit(
      new ClickURLLinkUnit("GoToUsersTab", "Click on the users tab").
      setURL("op=selectNode&objectId=usernode").
      addValidator(new ExpectTextValidator("Email"))
    ) ;
    for ( i in 1..AMOUNT){   
    //Add new user
    addWebUnit(
        new ClickURLLinkUnit("ClickAddUserIcon", "Click the add user icon").
        setURL("&uicomponent=UIListUser&op=addUser").
        addValidator(new ExpectFormIdValidator("accountForm"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("SubmitAddUserForm", "Click on save icon").
        setFormId("accountForm").
        setField("username","user"+i).
        setField("password1x","user"+i).
        setField("password2x","user"+i).
        setField("firstname","user's").
        setField("lastname","user's").
        setField("email","user@exoplatform.com").
        setField("op","save").
        addValidator(new ExpectTextValidator("New user has been created"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("ClickOnCancelIcon", "Go back to list user").
        setFormId("accountForm").
        setField("op","PhaseId[1].cancel").
        addValidator(new ExpectNoTextValidator("user's"))
    ) ;
    }
    addWebUnit(
        new ClickURLLinkUnit("ClickOnRefershIcon", "Click the add user icon").
        setURL("uicomponent=UIListUser&op=refresh").
        addValidator(new ExpectTextValidator("user@exoplatform.com"))
    ) ;    
    addWebUnit(
        new ClickURLLinkUnit("GotoNextPage", "Click on next page").
        setURL("uicomponent=UIPageListIterator&page=2").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIPageListIterator&page=1"))
    ) ;  
    addWebUnit(
        new ClickURLLinkUnit("BackOldPage", "Click on 1 page").
        setURL("&uicomponent=UIPageListIterator&page=1").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPageListIterator&page=2"))
    ) ;  
    addWebUnit(
        new ClickURLLinkUnit("GoToLastPage", "Click on last page").
        setURL("uicomponent=UIPageListIterator&page=2").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIPageListIterator&page=1"))
    ) ;  
    addWebUnit(
        new ClickURLLinkUnit("GoToFirstPage", "Click on first page").
        setURL("&uicomponent=UIPageListIterator&page=1").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPageListIterator&page=2"))
    ) ; 
    for ( i in 1..AMOUNT){   
      //Delete exoplatform account
      addWebUnit(
        new ClickURLLinkUnit("ClickDeleteAccount", "Delete Account").
        setURL("op=delete&objectId="+USER_ACCOUNT+i).
        addCondition(new HaveLinkWithURLCondition("op=delete&objectId="+USER_ACCOUNT+i))
      ) ;
    }
    for ( i in 1..AMOUNT){   
      //Delete exoplatform account
      addWebUnit(
        new ClickURLLinkUnit("ClickDeleteAccount", "Delete Account").
        setURL("op=delete&objectId="+USER_ACCOUNT+i).
        addCondition(new HaveLinkWithURLCondition("op=delete&objectId="+USER_ACCOUNT+i))
      ) ;
    }
  }
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite(CommonUnit.NAME_EXO_ADMIN, "exo", roles)] ;
  }
}
